DPDK patches and discussions
 help / color / mirror / Atom feed
From: Thomas Monjalon <thomas.monjalon@6wind.com>
To: dev@dpdk.org
Subject: [dpdk-dev] [PATCH 2/2] scripts: add build tests
Date: Fri, 23 Oct 2015 17:53:26 +0200	[thread overview]
Message-ID: <1445615606-3885-3-git-send-email-thomas.monjalon@6wind.com> (raw)
In-Reply-To: <1445615606-3885-1-git-send-email-thomas.monjalon@6wind.com>

This script helps to build a list of target with some custom options.
It tries to enable most of the options.
The examples and documentation are also built.

It uses some configuration from exported variables.
This config works on my machine:
export DPDK_DEP_PCAP=y
export DPDK_DEP_MOFED=y
       mlxdep=/opt/mofed-3.0
export DPDK_DEP_CFLAGS=-I$mlxdep/include
export DPDK_DEP_LDFLAGS=-L$mlxdep/lib
export DPDK_BUILD_TEST_CONFIGS='x86_64-native-linuxapp-gcc+shared+next
       x86_64-native-linuxapp-clang+shared+combined
       i686-native-linuxapp-gcc+combined'
export DPDK_MAKE_JOBS=8
export DPDK_NOTIFY=notify-send

Signed-off-by: Thomas Monjalon <thomas.monjalon@6wind.com>
---
 scripts/test-build.sh | 112 ++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 112 insertions(+)
 create mode 100755 scripts/test-build.sh

diff --git a/scripts/test-build.sh b/scripts/test-build.sh
new file mode 100755
index 0000000..517141d
--- /dev/null
+++ b/scripts/test-build.sh
@@ -0,0 +1,112 @@
+#! /bin/sh -e
+
+# Load config options:
+# - DPDK_BUILD_TEST_CONFIGS (target1+option1+option2 target2)
+# - DPDK_DEP_CFLAGS
+# - DPDK_DEP_LDFLAGS
+# - DPDK_DEP_MOFED (y/[n])
+# - DPDK_DEP_PCAP (y/[n])
+# - DPDK_NOTIFY (notify-send)
+. scripts/load-devel-config.sh
+
+print_usage () {
+	echo "usage: $(basename $0) [-jX] [-q] [config1 [config2] ...]]"
+}
+
+J=$DPDK_MAKE_JOBS
+quick=false
+while getopts hj:q ARG ; do
+	case $ARG in
+		j ) J=$OPTARG ;;
+		q ) quick=true ;;
+		h ) print_usage ; exit 0 ;;
+		? ) print_usage ; exit 1 ;;
+	esac
+done
+shift $(($OPTIND - 1))
+configs=${*:-$DPDK_BUILD_TEST_CONFIGS}
+
+success=false
+on_exit ()
+{
+	if [ "$DPDK_NOTIFY" = notify-send ] ; then
+		if $success ; then
+			notify-send -u low --icon=dialog-information 'DPDK build' 'finished'
+		elif [ -z "$signal" ] ; then
+			notify-send -u low --icon=dialog-error 'DPDK build' 'failed'
+		fi
+	fi
+}
+# catch manual interrupt to ignore notification
+trap "signal=INT ; trap - INT ; kill -INT $$" INT
+# notify result on exit
+trap on_exit EXIT
+
+cd $(dirname $(readlink -m $0))/..
+
+config () # <directory> <target> <options>
+{
+	if [ ! -e $1/.config ] ; then
+		echo Custom configuration
+		make T=$2 O=$1 config
+		echo $3 | grep -q next || \
+		sed -ri           's,(NEXT_ABI=)y,\1n,' $1/.config
+		! echo $3 | grep -q shared || \
+		sed -ri         's,(SHARED_LIB=)n,\1y,' $1/.config
+		! echo $3 | grep -q combined || \
+		sed -ri       's,(COMBINE_LIBS=)n,\1y,' $1/.config
+		echo $2 | grep -q '^i686' || \
+		sed -ri               's,(NUMA=)n,\1y,' $1/.config
+		sed -ri         's,(PCI_CONFIG=)n,\1y,' $1/.config
+		sed -ri    's,(LIBRTE_IEEE1588=)n,\1y,' $1/.config
+		sed -ri             's,(BYPASS=)n,\1y,' $1/.config
+		test "$DPDK_DEP_MOFED" != y || \
+		echo $2 | grep -q '^clang$' || \
+		echo $3 | grep -q 'shared.*combined' || \
+		sed -ri           's,(MLX4_PMD=)n,\1y,' $1/.config
+		echo $2 | grep -q '^i686' || \
+		sed -ri          's,(BNX2X_PMD=)n,\1y,' $1/.config
+		test "$DPDK_DEP_PCAP" != y || \
+		sed -ri               's,(PCAP=)n,\1y,' $1/.config
+		sed -ri        's,(KNI_VHOST.*=)n,\1y,' $1/.config
+		sed -ri           's,(SCHED_.*=)n,\1y,' $1/.config
+		! echo $2 | grep -q '^i686' || \
+		sed -ri              's,(POWER=)y,\1n,' $1/.config
+		sed -ri 's,(TEST_PMD_RECORD_.*=)n,\1y,' $1/.config
+		sed -ri            's,(DEBUG.*=)n,\1y,' $1/.config
+	fi
+}
+
+for conf in $configs ; do
+	target=$(echo $conf | cut -d'+' -f1)
+	options=$(echo $conf | cut -d'+' -sf2- --output-delimiter='-')
+	if [ -z "$options" ] ; then
+		dir=$target
+		config $dir $target
+		# Use install rule
+		make -j$J T=$target install EXTRA_CFLAGS=$DPDK_DEP_CFLAGS EXTRA_LDFLAGS=$DPDK_DEP_LDFLAGS
+		$quick || make -j$J T=$target examples O=$dir/examples EXTRA_LDFLAGS=$DPDK_DEP_LDFLAGS
+	else
+		dir=$target-$options
+		config $dir $target $options
+		echo "================== Build $dir"
+		# Use O variable without install
+		make -j$J O=$dir EXTRA_CFLAGS=$DPDK_DEP_CFLAGS EXTRA_LDFLAGS=$DPDK_DEP_LDFLAGS
+		echo "================== Build examples for $dir"
+		make -j$J -sC examples RTE_SDK=$(pwd) RTE_TARGET=$dir O=$(readlink -m $dir/examples) EXTRA_LDFLAGS=$DPDK_DEP_LDFLAGS
+	fi
+	echo "################## $dir done."
+	! $quick || break
+done
+
+if ! $quick ; then
+	mkdir -p .check
+	echo "================== Build doxygen HTML API"
+	make doc-api-html >/dev/null 2>.check/doc.txt
+	echo "================== Build sphinx HTML guides"
+	make doc-guides-html >/dev/null 2>>.check/doc.txt
+	echo "================== Check docs"
+	diff -u /dev/null .check/doc.txt
+fi
+
+success=true
-- 
2.5.2

  parent reply	other threads:[~2015-10-23 15:54 UTC|newest]

Thread overview: 27+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2015-10-23 15:53 [dpdk-dev] [PATCH 0/2] more basic tests Thomas Monjalon
2015-10-23 15:53 ` [dpdk-dev] [PATCH 1/2] scripts: add checkpatch wrapper Thomas Monjalon
2015-10-23 16:03   ` Stephen Hemminger
2015-10-23 16:34     ` Thomas Monjalon
2015-10-23 16:56       ` Stephen Hemminger
2015-10-23 16:58       ` Stephen Hemminger
2015-10-23 20:27         ` Thomas Monjalon
2015-10-29 12:17   ` Bruce Richardson
2015-10-29 12:33   ` David Marchand
2015-10-29 13:03     ` Thomas Monjalon
2015-10-29 13:24       ` Bruce Richardson
2015-10-29 13:34         ` Thomas Monjalon
2015-10-29 13:48           ` Bruce Richardson
2015-10-29 13:54             ` David Marchand
2015-10-29 13:57               ` Thomas Monjalon
2015-10-30 16:16                 ` Bruce Richardson
2015-10-30 16:23                   ` Thomas Monjalon
2015-11-02 10:28                     ` Van Haaren, Harry
2015-11-02 10:33                       ` Bruce Richardson
2015-10-23 15:53 ` Thomas Monjalon [this message]
2015-11-23  1:40 ` [dpdk-dev] [PATCH v2 0/2] more basic tests Thomas Monjalon
2015-11-23  1:40   ` [dpdk-dev] [PATCH v2 1/2] scripts: add checkpatch wrapper Thomas Monjalon
2015-11-24 16:33     ` Bruce Richardson
2015-11-23  1:40   ` [dpdk-dev] [PATCH v2 2/2] scripts: add build tests Thomas Monjalon
2015-11-24 17:49     ` Mcnamara, John
2015-11-24 18:14       ` Thomas Monjalon
2015-12-03 17:39   ` [dpdk-dev] [PATCH v2 0/2] more basic tests Thomas Monjalon

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1445615606-3885-3-git-send-email-thomas.monjalon@6wind.com \
    --to=thomas.monjalon@6wind.com \
    --cc=dev@dpdk.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).